#if !defined SCANNER_H
#define SCANNER_H

/* Tokens returned by the scanner. */
enum {
  DONE=0, 			/* EOF */
  ITEM, 			/* Data item */
  EQ, 				/* Equal sign character */
  NL, 				/* Newline character */
  SEP, 				/* Audit record separator  */
  AVC,				/* Special case for type=AVC */
};

/* Return the next token. */
int yylex(void);

/* Get the text associated with a token. */
const char *getyytext(void);

/* Report an error along with its location in the source file. */
int yyerror(const char *);

/* Tell the scanner the name of the source file for better error
   messages. */
void setfile(const char *);

#endif
