#!/usr/bin/env python

from util import *
from dutil import *
from psl_parsing import nodes, akop, PslWriter, SpecString, node_factory

import pygtk
pygtk.require('2.0')
import gtk
import gobject

from gui import *
import config

global all_pattern_assertions
all_pattern_assertions = []

PRGM.save_changes = False

def get_analyst_input (pattern_assertions, no_gui):
    """ This function kicks off the GUI asking for user interventions """
    global all_pattern_assertions
    all_pattern_assertions = pattern_assertions
    if not no_gui:
        global app
        global root
        import dialog
        dialog.BuildIF(PRGM.name)
        gtk.main()
    else:
        #need to set default values for security contexts of files
        fixer.adjust_pattern_list_finalCB() # sets up contrib list
        # need something to determine type from contrib list
        fixer.do_policy_generationCB()

###################################################################

class CastingForSubmodules:
    def when_done(self, the_done_button = None):
        response_nbr = self.choices['choice'].get_active()
        Submodules(self.options[response_nbr])
        self.window.destroy()

    def __init__(self):
        self.init_gui(
            )
    def init_gui(self):
        self.window = gtk.Dialog() 
        self.window.set_title('Step 2a - Preference for type specialization (defaults to minimize)' )
        ysz = 150
        self.window.set_size_request(400, min(MAX_WINDOW_Y_SIZE,ysz))
        	

        scrolled_window = gtk.ScrolledWindow()
	scrolled_window.set_border_width(10)
	scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(30000, 65000, 50000)) 
	self.window.vbox.pack_start(scrolled_window, 1, 1, 0)
	scrolled_window.show()
	self.choices = {}
        box1 = gtk.VBox(0, 0)
        scrolled_window.add_with_viewport(box1)
        box1.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(60000, 60000, 30000))
        box1.show()

        box2 = gtk.HBox(0, 10)
        box2.set_border_width(10)
        label = gtk.Label('Preference')
        box2.pack_start(label, 0, 0, 0)
        label.show()
        opt = gtk.combo_box_new_text()
        self.choices['choice'] = opt
        self.options = ['Minimize new types', 'Determine new types from code module use', \
                   'Select processes that should be typed']
        opt.items = self.options
        count = 1
        opt.reverse_labels = {}
        for choice in self.options:
            opt.reverse_labels[choice] = choice
            opt.insert_text(count, choice)
            opt.set_active(0)
            count = count + 1

        box2.pack_start(opt, 1, 1, 0)
        opt.show()

        box1.pack_start(box2, 1, 1, 0)
        box2.show()

        box2 = gtk.HBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect("clicked", self.when_done)
        box2.pack_start(button, 0, 1, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        #button.grab_default()
        button.show()
        self.window.show()






####################################################################   
class Submodules:
    """Identify Submodules - nodes that need special access"""

    def when_done (self, window):
        for b in self.buttons:
            if b.get_active():
                nodes[b.temp_name].entry_point = 1
        declared = [x.temp_name for x in self.buttons if x.get_active()]
        #print declared
        if Exists(declared):
            PopulateSubmodule(declared[0], declared[1:])
        else:
            if PRGM.save_changes:
                PslWriter()
            TopLevel(all_pattern_assertions)            
        window.destroy()
        
    def callback(self, widget, data=None):
        print widget.temp_name
        #print widget.get_active()
        #fixer.set_active_valueCB(data, ("OFF", "ON")[widget.get_active()])


    def close_application(self, widget, event, data=None):
        gtk.main_quit()
        return 0

    def __init__(self, option):
        self.casting_option = option
        #print option
        self.name = PRGM.name
        self.buttons = []
        self.init_gui(self.name)
        
            
    def init_gui(self, mod_name):
        self.window = gtk.Dialog() 
        self.window.set_title("Step 2b - Select processes that require special access privileges (default is application only)")
        self.window.set_border_width(0)
        self.window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(30000, 65000, 50000)) 
        ysz = 1000
        process_keys = nodes.keys()
        process_keys.sort()
        #list depends on casting_option
        casting = self.casting_option

        if casting == 'Minimize new types':
            processes = [nodes[get_current_program().name]]
        elif casting == 'Determine new types from "code module" use':
            processes = [x for x in nodes.values() if akop(x.name, PRGM.name) \
                     and x.type.lower() in ['application', 'code_module']] + \
                     [nodes[get_current_program().name]]
        elif casting == 'Select processes that should be typed':
            processes = [x for x in nodes.values() \
                         if x.type.lower() in ['application', 'daemon', 'process']]
        else:
            processes = [x for x in nodes.values() if x.type.lower() != 'data_file']
            
        #print "Processes = " + str(processes)
        nbr = len(processes)
        if 0==nbr:
            self.when_done(self.window)
        if nbr < 6:
            ysz = 120 * nbr
        self.window.set_size_request(600, min(MAX_WINDOW_Y_SIZE,ysz))

        scrolled_window = gtk.ScrolledWindow()
        scrolled_window.set_border_width(10)
        scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.window.vbox.pack_start(scrolled_window, 1, 1, 0)
        scrolled_window.show()

        self.window.connect("delete_event", self.close_application)


        self.window.set_border_width(0)

        box1 = gtk.VBox(0, 0)
        scrolled_window.add_with_viewport(box1)
        box1.show()
        #create_button(self, box1, "Help", self.help)
        box2 = gtk.VBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()
        
        for k in process_keys:
            q = nodes[k]
            if q in processes:
                button = gtk.CheckButton(q.name)
                button.temp_name = q.name
                activep = 0
                if q.entry_point or q.name == PRGM.name:
                    activep = 1
                self.buttons.append(button)
                button.set_active(activep)
                button.connect("toggled", self.callback, q)
                box2.pack_start(button, 1, 1, 0)
                button.show()

        separator = gtk.HSeparator()
        box1.pack_start(separator, 0, 1, 0)
        separator.show()

 
        box2 = gtk.HBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect_object("clicked", self.when_done, self.window)
        box2.pack_start(button, 0, 1, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()

        self.window.show()

##################################################################
        
class PopulateSubmodule:
    """ Capture decisions on properties of a submodule """
    
    def callback(self, widget, data=None):
        print self.name + "." + data.name + " = " + str(widget.get_active())
        activep = widget.get_active()
        if activep:
            setattr(nodes[self.name], data.name, True)
        #fixer.set_active_valueCB(data, ("OFF", "ON")[widget.get_active()])

    def when_done(self, window):
        #fixer.adjust_pattern_list_finalCB()
        global all_pattern_assertions
        for b in self.buttons:
            setattr(nodes[self.name], b.temp_name, b.get_active())
        if self.rest != []:
            PopulateSubmodule(self.rest[0], self.rest[1:])
        else:
            if PRGM.save_changes:
                PslWriter()
            TopLevel(all_pattern_assertions)
        window.destroy()
        

    def close_application(self, widget, event, data=None):
        gtk.main_quit()
        return 0

    def __init__(self, mod_name, rest):
        self.name = mod_name
        self.rest = rest
        self.init_gui(mod_name)
        
            
    def init_gui(self, mod_name):
        self.window = gtk.Dialog() 
        self.window.set_title("Step 3 - Set expected behavior for " + mod_name + " submodule")
        self.window.set_border_width(0)
        self.window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(30000, 65000, 50000)) 
        ysz = 1000
        nbr = len(questions_dict.keys())
        if 0==nbr:
            return
        if nbr < 6:
            ysz = 80 * nbr
        self.window.set_size_request(600, min(MAX_WINDOW_Y_SIZE,ysz))

        self.buttons = []
        scrolled_window = gtk.ScrolledWindow()
        scrolled_window.set_border_width(10)
        scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.window.vbox.pack_start(scrolled_window, 1, 1, 0)
        scrolled_window.show()

        self.window.connect("delete_event", self.close_application)


        self.window.set_border_width(0)

        box1 = gtk.VBox(0, 0)
        scrolled_window.add_with_viewport(box1)
        box1.show()
        #create_button(self, box1, "Help", self.help)
        box2 = gtk.VBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()
        nodes[mod_name].entry_point = 1

        for q in questions_dict.values():
            button = gtk.CheckButton(q.brief_desc)
            button.temp_name = q.name
            activep = q.is_it_active(nodes[self.name])
            button.set_active(activep)
            self.buttons.append(button)
            button.connect("toggled", self.callback, q)
            box2.pack_start(button, 1, 1, 0)
            button.show()

        separator = gtk.HSeparator()
        box1.pack_start(separator, 0, 1, 0)
        separator.show()

 
        box2 = gtk.HBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect_object("clicked", self.when_done, self.window)
        box2.pack_start(button, 0, 1, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()

        self.window.show()

################################################################
        
class BuildIF:
    """ gui to determine IF requirements for the application"""
    def callback(self, widget, data=None):
        print "IF callback: " + str(data)
        print widget.get_active()
        #fixer.set_active_valueCB(data, ("OFF", "ON")[widget.get_active()])

    def when_done(self, window):
        #fixer.adjust_pattern_list_finalCB()
        self.application.provides = []
        for b in self.buttons:
            if b.get_active():
                self.application.provides.append(b.temp_name)
        CastingForSubmodules()
        window.destroy()
        

    def close_application(self, widget, event, data=None):
        gtk.main_quit()
        return 0

    def __init__(self, mod_name):
        pname = get_current_program().name
        if pname in nodes.keys():
             self.application = nodes[pname]
        else:
            self.application = node_factory(SpecString("", 0), pname, 'process')
        self.init_gui(mod_name)

            
    def init_gui(self, mod_name):
        self.window = gtk.Dialog() 
        self.window.set_title("Polgen: Step 1 - Indicate permissions to be provided to other modules using " + mod_name)
        self.window.set_border_width(0)
        self.window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(30000, 65000, 50000))
        ysz = 1000
        nbr = len(if_dict.keys())
        if 0==nbr:
            return
        if nbr < 6:
            ysz = 20 * nbr
        self.window.set_size_request(600, min(MAX_WINDOW_Y_SIZE,ysz))

        scrolled_window = gtk.ScrolledWindow()
        scrolled_window.set_border_width(10)
        scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.window.vbox.pack_start(scrolled_window, 1, 1, 0)
        scrolled_window.show()

        self.window.connect("delete_event", self.close_application)


        self.window.set_border_width(0)

        box1 = gtk.VBox(0, 0)
        scrolled_window.add_with_viewport(box1)
        box1.show()
        box2 = gtk.VBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()
        self.buttons = []
        for q in if_dict.values():
            #print q.name
            button = gtk.CheckButton(q.brief_desc)
            button.temp_name = q.name
            if q.name in self.application.provides:
                activep = 1
            else:
                activep = q.active_flag
            button.set_active(activep)
            self.buttons.append(button)
            button.connect("toggled", self.callback, q)
            box2.pack_start(button, 1, 1, 0)
            button.show()

        separator = gtk.HSeparator()
        box1.pack_start(separator, 0, 1, 0)
        separator.show()

 
        box2 = gtk.HBox(0, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, 0, 1, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect_object("clicked", self.when_done, self.window)
        box2.pack_start(button, 0, 1, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()

        self.window.show()
