
def repair_sub(module, sub):
    if module == sub:
        sub = ""
    elif sub != "":
        sub = "_" + sub
    return sub

def response_gen_basic (module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["type " + module + sub + "_t; \n",
                "domain_type(" + module + sub + "_t) \n",
                "role system_r types " + module + sub + "_t; \n",
                "type " + module + sub + "_exec_t; \n",
                "domain_entry_file(" + module + sub + "_t, " + module + sub + "_exec_t) \n",
                "type " + module + sub + "_tmp_t; \n",
                "files_tmp_file(" + module + sub + "_tmp_t) \n",
                "allow " + module + sub + "_t " + module + sub + "_tmp_t:dir create_dir_perms; \n",
                "allow " + module + sub + "_t " + module + sub + "_tmp_t:file create_file_perms; \n"]
    return toreturn

def response_tcp(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t self:unix_stream_socket  create_socket_perms; \n",
                "allow " + module + sub + "_t self:tcp_socket create_stream_socket_perms; \n",
                "corenet_tcp_sendrecv_all_if(" + module + sub + "_t) \n",
                "corenet_tcp_sendrecv_all_nodes(" + module + sub + "_t) \n",
                "corenet_tcp_sendrecv_all_ports(" + module + sub + "_t) \n",
                "corenet_tcp_bind_all_nodes(" + module + sub + "_t) \n"]
    return toreturn

def response_raw(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t self:unix_stream_socket  create_socket_perms; \n",
                "allow " + module + sub + "_t self:tcp_socket create_stream_socket_perms; \n",
                "corenet_raw_sendrecv_all_if(" + module + sub + "_t) \n",
                "corenet_raw_sendrecv_all_nodes(" + module + sub + "_t) \n"]
    return toreturn
    
def response_udp(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t self:unix_dgram_socket create_socket_perms; \n",
                "allow " + module + sub + "_t self:udp_socket create_stream_socket_perms; \n",
                "corenet_udp_sendrecv_all_if(" + module + sub + "_t) \n",
                "corenet_udp_sendrecv_all_nodes(" + module + sub + "_t) \n",
                "corenet_udp_sendrecv_all_ports(" + module + sub + "_t) \n",
                "corenet_udp_bind_all_nodes(" + module + sub + "_t) \n"]
    return toreturn

def response_read(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t " + module + "_data_t:dir create_dir_perms; \n",
               "allow " + module + sub + "_t " + module + "_data_t:file create_file_perms; \n"]
    return toreturn

def response_write(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t " + module + "_data_t:dir create_dir_perms; \n",
                "allow " + module + sub + "_t " + module + "_data_t:file create_file_perms; \n"]
    return toreturn

def response_exec_processes(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["corecmd_exec_bin(" + module + sub + "_t) \n"]
    return toreturn
               
def response_var(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["files_list_var(" + module + sub + "_t)\n"]
    return toreturn

def response_var_lib(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["files_list_var_lib(" + module + sub + "_t) \n"]
    return toreturn

def response_etc(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["files_read_etc_runtime_files(" + module + sub + "_t) \n"]
    return toreturn

def response_symlinks(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["allow " + module + sub + "_t " + module + "_data_t:lnk_file create_lnk_perms; \n"]
    return toreturn

def response_manage_logs(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["logging_manage_all_logs(" + module + sub + "_t) \n"]
    return toreturn

def response_localization(module, sub):
    sub = repair_sub(module, sub)
    toreturn = ["miscfiles_read_localization(" + module + sub + "_t) \n"]
    return toreturn

    
               

    





